
 
 // SDLIB ######################################################################################################
 // **************************************************************************************************************************
 // *   Die SDLIB:                                                                                                           *
 // *   =====================================                                                                                *
 // *   Die SDLIB (bestehend aus den Files "sdlib.h" & "sdlib.c") stellt die Routienen fr die Ansteuerung                   *
 // *   einer SD-Karte mittels AVR in CodeVision bereit. Diese werden in dem FAT - File - System verwendet.                  *
 // *   Ursprnglich wurden diese von Ulrich Radig mittels WinAVR erstellt.                                                  *
 // *   s. www.ulrichradig.de   bzw. Disclaimer am Ende                                                                      *
 // *                                                                                                                        *
 // *                                                                                                                        *
 // *                                                                                                                        *
 // **************************************************************************************************************************
  
 //-------------------------------------------------------------------------------------------------   
 //      DEFINES
 //-------------------------------------------------------------------------------------------------
  //-----MMC-Karte------------------
    #define MMC_Disable()     MMC_Write|= (1<<MMC_Chip_Select);  //set MMC_Chip_Select to high (MMC/SD-Karte Inaktiv)
    #define MMC_Enable()      MMC_Write&=~(1<<MMC_Chip_Select);  //set MMC_Chip_Select to low (MMC/SD-Karte Aktiv)

    #define MMC_Write  		    PORTB	                             //Port an der die MMC/SD-Karte angeschlossen ist also des SPI 
    #define MMC_Read 		      PINB
    #define MMC_Direction_REG	DDRB	
    
    #define SPI_DI    		    3       //3                        //Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
    #define SPI_DO    		    2       //2                        //Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
    #define SPI_Clock  		    1       //1                        //Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
    #define MMC_Chip_Select   0       //4                        //Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
    //#define SPI_SS    		  4       //0                        //Nicht Benutz mu� aber definiert werden
    
    //Bits vom SPI Controll Register (SPCR)
    #define SPIE              7
    #define SPE               6
    #define DORD              5
    #define MSTR              4
    #define CPOL              3
    #define CPHA              2
    #define SPR1              1
    #define SPR0              0  
    //Bits vom SPI Status Register (SPSR)
    #define SPIF              7
    #define WCOL              6
    // n/a
    #define SPI2X             0  
    
    #define SD_Detect         PINE & 0x40                        //Anschlu von CardDetect an SD-Karten-Fassung (low-aktiv)  
    #define SD_WriteProtect   PINB.4                             //Anschlu von WriteProtect an SD-Karten-Fassung (high-aktiv)
     
    
    
    
 //-------------------------------------------------------------------------------------------------   
 //      PROTOTYPEN
 //-------------------------------------------------------------------------------------------------
  //-----MMC-Card------
    unsigned char   mmc_read_byte(void);
    void            mmc_write_byte(unsigned char);
    void            mmc_read_block(unsigned char *,unsigned char *,unsigned in);
    unsigned char   mmc_init(void);                                    
    unsigned char   mmc_read_sector (unsigned long,unsigned char *);   
    unsigned char   mmc_write_sector (unsigned long,unsigned char *);  
    unsigned char   mmc_write_command (unsigned char *);               
    //unsigned char mmc_read_csd (unsigned char *);                  
    //unsigned char mmc_read_cid (unsigned char *);                  
    unsigned char   mmc_write_atAddr_end(void);                        
    unsigned char   mmc_write_atAddr_start(unsigned long int addr);     


/*#######################################################################################
Dieses Programm ist freie Software. Sie k�nnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation ver�ffentlicht, 
weitergeben und/oder modifizieren, entweder gem�� Version 2 der Lizenz oder 
(nach Ihrer Option) jeder sp�teren Version. 

Die Ver�ffentlichung dieses Programms erfolgt in der Hoffnung, 
da� es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
F�R EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

